#include "norwegianwoodstyle.h"
#include <QComboBox>
#include <QPainter>
#include <QPainterPath>
#include <QPushButton>
#include <QStyleFactory>
#include <QDebug>
#include <QtWidgets>

Norwegian_Wood_Style::Norwegian_Wood_Style() :
        QProxyStyle(QStyleFactory::create("windows")) {
    setObjectName("NorwegianWood");
}

//! [0]
QPalette Norwegian_Wood_Style::standardPalette() const {
    if (!m_standard_palette.isBrushSet(QPalette::Disabled, QPalette::Mid)) {
        QColor brown(212, 140, 95);
        QColor beige(236, 182, 120);
        QColor slightly_opaque_black(0, 0, 0, 63);
        QImage background_image(":/images/woodbackground.png");
        QImage button_image(":/images/woodbutton.png");
        QImage mid_image = button_image.convertToFormat(QImage::Format_RGB32);
        QPainter painter;
        painter.begin(&mid_image);
        painter.setPen(Qt::NoPen);
        painter.fillRect(mid_image.rect(), slightly_opaque_black);
        painter.end();
        QPalette palette(brown);
        palette.setBrush(QPalette::BrightText, Qt::white);
        palette.setBrush(QPalette::Base, beige);
        palette.setBrush(QPalette::Highlight, Qt::darkGreen);
        set_texture(palette, QPalette::Button, button_image);
        set_texture(palette, QPalette::Mid, mid_image);
        set_texture(palette, QPalette::Window, background_image);
        QBrush brush = palette.window();
        brush.setColor(brush.color().darker());
        palette.setBrush(QPalette::Disabled, QPalette::WindowText, brush);
        palette.setBrush(QPalette::Disabled, QPalette::Text, brush);
        palette.setBrush(QPalette::Disabled, QPalette::ButtonText, brush);
        palette.setBrush(QPalette::Disabled, QPalette::Base, brush);
        palette.setBrush(QPalette::Disabled, QPalette::Button, brush);
        palette.setBrush(QPalette::Disabled, QPalette::Mid, brush);
        m_standard_palette = palette;
    }
    return m_standard_palette;
}

void Norwegian_Wood_Style::polish(QWidget *widget) {
    if (qobject_cast<QPushButton *>(widget)
        || qobject_cast<QComboBox *>(widget))
        widget->setAttribute(Qt::WA_Hover, true);
}

void Norwegian_Wood_Style::unpolish(QWidget *widget) {
    if (qobject_cast<QPushButton *>(widget)
        || qobject_cast<QComboBox *>(widget))
        widget->setAttribute(Qt::WA_Hover, false);
}

int Norwegian_Wood_Style::pixelMetric(PixelMetric metric,
                                    const QStyleOption *option,
                                    const QWidget *widget) const {
    switch (metric) {
        case PM_ComboBoxFrameWidth:
            return 8;
        case PM_ScrollBarExtent:
            return QProxyStyle::pixelMetric(metric, option, widget) + 4;
        default:
            return QProxyStyle::pixelMetric(metric, option, widget);
    }
}

int Norwegian_Wood_Style::styleHint(StyleHint hint, const QStyleOption *option,
                                  const QWidget *widget,
                                  QStyleHintReturn *returnData) const {
    switch (hint) {
        case SH_DitherDisabledText:
            return int(false);
        case SH_EtchDisabledText:
            return int(true);
        default:
            return QProxyStyle::styleHint(hint, option, widget, returnData);
    }
}

void Norwegian_Wood_Style::drawPrimitive(PrimitiveElement element,
                                       const QStyleOption *option,
                                       QPainter *painter,
                                       const QWidget *widget) const {
    switch (element) {
        case PE_PanelButtonCommand: {
            int delta = (option->state & State_MouseOver) ? 64 : 0;
            QColor slightly_opaque_black(0, 0, 0, 63);
            QColor semi_transparent_white(255, 255, 255, 127 + delta);
            QColor semi_transparent_black(0, 0, 0, 127 - delta);
            int x, y, width, height;
            option->rect.getRect(&x, &y, &width, &height);
            QPainterPath round_rect = round_rect_path(option->rect);
            int radius = qMin(width, height) / 2;
            QBrush brush;
            bool darker;
            const QStyleOptionButton *button_option =
                    qstyleoption_cast<const QStyleOptionButton *>(option);
            if (button_option
                && (button_option->features & QStyleOptionButton::Flat)) {
                brush = option->palette.window();
                darker = (option->state & (State_Sunken | State_On));
            } else {
                if (option->state & (State_Sunken | State_On)) {
                    brush = option->palette.mid();
                    darker = !(option->state & State_Sunken);
                } else {
                    brush = option->palette.button();
                    darker = false;
                }
            }
            painter->save();
            painter->setRenderHint(QPainter::Antialiasing, true);
            painter->fillPath(round_rect, brush);
            if (darker)
                painter->fillPath(round_rect, slightly_opaque_black);
            int pen_width;
            if (radius < 10)
                pen_width = 3;
            else if (radius < 20)
                pen_width = 5;
            else
                pen_width = 7;
            QPen top_pen(semi_transparent_white, pen_width);
            QPen bottom_pen(semi_transparent_black, pen_width);
            if (option->state & (State_Sunken | State_On))
                qSwap(top_pen, bottom_pen);
            int x1 = x;
            int x2 = x + radius;
            int x3 = x + width - radius;
            int x4 = x + width;
            if (option->direction == Qt::RightToLeft) {
                qSwap(x1, x4);
                qSwap(x2, x3);
            }
            QPolygon top_half;
            top_half << QPoint(x1, y)
                    << QPoint(x4, y)
                    << QPoint(x3, y + radius)
                    << QPoint(x2, y + height - radius)
                    << QPoint(x1, y + height);
            painter->setClipPath(round_rect);
            painter->setClipRegion(top_half, Qt::IntersectClip);
            painter->setPen(top_pen);
            painter->drawPath(round_rect);
            QPolygon bottom_half = top_half;
            bottom_half[0] = QPoint(x4, y + height);
            painter->setClipPath(round_rect);
            painter->setClipRegion(bottom_half, Qt::IntersectClip);
            painter->setPen(bottom_pen);
            painter->drawPath(round_rect);
            painter->setPen(option->palette.windowText().color());
            painter->setClipping(false);
            painter->drawPath(round_rect);
            painter->restore();
        }
            break;
        default:
            QProxyStyle::drawPrimitive(element, option, painter, widget);
    }
}

void Norwegian_Wood_Style::drawControl(ControlElement element,
                                     const QStyleOption *option,
                                     QPainter *painter,
                                     const QWidget *widget) const {
    switch (element) {
        case CE_PushButtonLabel: {
            QStyleOptionButton my_button_option;
            auto btn = (QPushButton*)(widget);
            auto button_option = qstyleoption_cast<const QStyleOptionButton *>(option);
            if (button_option) {
                my_button_option = *button_option;
                QBrush bright  = my_button_option.palette.brightText();
                if(!btn->isFlat()){
                    my_button_option.palette.setBrush(QPalette::ButtonText, bright);
                }
                if (my_button_option.palette.currentColorGroup()
                    != QPalette::Disabled) {
                    if (my_button_option.state & (State_Sunken | State_On)) {
                        my_button_option.palette.setBrush(QPalette::ButtonText, bright);
                    }
                }
            }
            QProxyStyle::drawControl(element, &my_button_option, painter, widget);
        }
            break;
        default:
            QProxyStyle::drawControl(element, option, painter, widget);
    }
}

void Norwegian_Wood_Style::set_texture(QPalette &palette, QPalette::ColorRole role,
                                    const QImage &image) {
    for (int i = 0; i < QPalette::NColorGroups; ++i) {
        QBrush brush(image);
        brush.setColor(palette.brush(QPalette::ColorGroup(i), role).color());
        palette.setBrush(QPalette::ColorGroup(i), role, brush);
    }
}

QPainterPath Norwegian_Wood_Style::round_rect_path(const QRect &rect) {
    int radius = qMin(rect.width(), rect.height()) / 4;
    int diam = 2 * radius;
    int x1, y1, x2, y2;
    rect.getCoords(&x1, &y1, &x2, &y2);
    QPainterPath path;
    path.moveTo(x2, y1 + radius);
    path.arcTo(QRect(x2 - diam, y1, diam, diam), 0.0, +90.0);
    path.lineTo(x1 + radius, y1);
    path.arcTo(QRect(x1, y1, diam, diam), 90.0, +90.0);
    path.lineTo(x1, y2 - radius);
    path.arcTo(QRect(x1, y2 - diam, diam, diam), 180.0, +90.0);
    path.lineTo(x1 + radius, y2);
    path.arcTo(QRect(x2 - diam, y2 - diam, diam, diam), 270.0, +90.0);
    path.closeSubpath();
    return path;
}
